type Filter = (module: any) => boolean;
interface Module {
	exports: {
		default?: any;
		__esModule?: any;
	};
}

let getModules: () => [];

let modules: {
	c: [];
};
window.webpackChunkdiscord_app.push([
	[Math.random().toString(36)],
	{},
	(e: { c: [] }) => {
		modules = e;
	}
]);
getModules = () => modules.c;

function filter(filter: Filter, moduleList: Module[], onlyFirst: boolean = false): Module["exports"] | Module["exports"][] {
	let modules: Module["exports"][] = [];
	let first = undefined
	for (const mod in moduleList) {
		const module = moduleList[mod].exports;
		if (module) {
			if (module.default && module.__esModule && filter(module.default)) {
				if (onlyFirst) {
					first = module.default;
					break
				}
				else {
					modules.push(module.default);
				}
			} else if (filter(module)) {
				if (onlyFirst) {
					first = module;
					break
				}
				else {
					modules.push(module);
				}
			}
		}
	}
	return onlyFirst ? first as Module["exports"] : modules;
}

let webpack = {
	modules: getModules(),
	getModules,
	filter: filter,
	find: (filter: Filter) => webpack.filter(filter, webpack.modules, true),
	findAll: (filter: Filter) => webpack.filter(filter, webpack.modules),
	findByProps: (...props: any[]) => {
		return webpack.find((module) => {
			return props.every((prop) => module[prop] !== undefined);
		});
	},
	findByPropsAll: (...props: any[]) => {
		return webpack.findAll((module) =>
			props.every((prop) => module[prop] !== undefined)
		);
	},
	findByDisplayName: (prop: any) => {
		return webpack.find((m) => m?.displayName === prop);
	},
	findByDisplayNameAll: (prop: any) => {
		return webpack.findAll((m) => m?.displayName === prop);
	},
	findByStrings: (...props: string[]) => {
		return webpack.find((module) =>
			props.every((prop) => module.toString().contains(prop))
		);
	},
	reloadModules: () => {
		//NOTE: i have no idea why this could even feasibly need to be used, but i'm adding it anyways
		webpack.modules = getModules();
	}
};

export default webpack;
